Index: trunk/src/VBox/Devices/EFI/FirmwareNew/IntelFrameworkModulePkg/Library/GenericBdsLib/BdsConsole.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/IntelFrameworkModulePkg/Library/GenericBdsLib/BdsConsole.c	(revision 77671)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/IntelFrameworkModulePkg/Library/GenericBdsLib/BdsConsole.c	(revision 77672)
@@ -217,6 +217,4 @@
   VBoxLogFlowFuncEnter();
   VBoxLogFlowFuncMarkVar(ConVarName, "%s");
-  VBoxLogFlowFuncMarkDP(CustomizedConDevicePath);
-  VBoxLogFlowFuncMarkDP(ExclusiveDevicePath);
   VarConsole      = NULL;
   DevicePathSize  = 0;
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/Apple.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/Apple.c	(revision 77671)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/Apple.c	(revision 77672)
@@ -108,5 +108,5 @@
   EFI_PARTITION_INFO_PROTOCOL  PartitionInfo;
 
-  VBoxLogFlowFuncMarkDP(DevicePath);
+  VBoxLogFlowFuncEnter();
   Found         = EFI_NOT_FOUND;
   Media         = BlockIo->Media;
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/ElTorito.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/ElTorito.c	(revision 77671)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/ElTorito.c	(revision 77672)
@@ -63,7 +63,4 @@
   EFI_PARTITION_INFO_PROTOCOL  PartitionInfo;
 
-#ifdef VBOX
-  VBoxLogFlowFuncMarkDP(DevicePath);
-#endif
   Found         = EFI_NOT_FOUND;
   Media         = BlockIo->Media;
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/Gpt.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/Gpt.c	(revision 77671)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/Gpt.c	(revision 77672)
@@ -221,7 +221,4 @@
   EFI_PARTITION_INFO_PROTOCOL  PartitionInfo;
 
-#ifdef VBOX
-  VBoxLogFlowFuncMarkDP(DevicePath);
-#endif
   ProtectiveMbr = NULL;
   PrimaryHeader = NULL;
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/Mbr.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/Mbr.c	(revision 77671)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/Mbr.c	(revision 77672)
@@ -150,7 +150,4 @@
   LastBlock = BlockIo->Media->LastBlock;
 
-#ifdef VBOX
-  VBoxLogFlowFuncMarkDP(DevicePath);
-#endif
   Mbr = AllocatePool (BlockSize);
   if (Mbr == NULL) {
@@ -232,5 +229,9 @@
       ZeroMem (&PartitionInfo, sizeof (EFI_PARTITION_INFO_PROTOCOL));
       PartitionInfo.Revision = EFI_PARTITION_INFO_PROTOCOL_REVISION;
-      PartitionInfo.Type     = PARTITION_TYPE_OTHER;
+      PartitionInfo.Type     = PARTITION_TYPE_MBR;
+      if (Mbr->Partition[Index].OSIndicator == EFI_PARTITION) {
+        PartitionInfo.System = 1;
+      }
+      CopyMem (&PartitionInfo.Info.Mbr, &Mbr->Partition[Index], sizeof (MBR_PARTITION_RECORD));
 
       Status = PartitionInstallChildHandle (
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/Partition.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/Partition.c	(revision 77671)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/MdeModulePkg/Universal/Disk/PartitionDxe/Partition.c	(revision 77672)
@@ -91,7 +91,4 @@
     // if yes, go on checking other conditions
     //
-#ifdef VBOX
-    VBoxLogFlowFuncMarkDP(RemainingDevicePath);
-#endif
     if (!IsDevicePathEnd (RemainingDevicePath)) {
       //
@@ -164,7 +161,4 @@
                   );
   if (Status == EFI_ALREADY_STARTED) {
-#ifdef VBOX
-    VBoxLogFlowFuncMarkDP(ParentDevicePath);
-#endif
     return EFI_SUCCESS;
   }
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/MdePkg/Include/Library/DebugLib.h
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/MdePkg/Include/Library/DebugLib.h	(revision 77671)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/MdePkg/Include/Library/DebugLib.h	(revision 77672)
@@ -528,8 +528,4 @@
 
 #if defined(VBOX)
-# ifdef __EFI_DEVICE_PATH_PROTOCOL_H__
-CHAR16 *VBoxDebugDevicePath2Str(IN EFI_DEVICE_PATH_PROTOCOL *pDevicePath);
-CHAR16 *VBoxDebugHandleDevicePath2Str(IN EFI_HANDLE hHandle);
-# endif
 VOID EFIAPI VBoxLogWorker(const char *pszFormat, ...);
 
@@ -554,8 +550,4 @@
         VBoxLog(("%a:" VBOX_XSTR(__LINE__) ": " #rc "=0x%x (%r)\n", __FUNCTION__, rcLog, rcLog)); \
     } while (0)
-#  define VBoxLogFlowFuncMarkDP(dp) \
-    VBoxLog(("%a:" VBOX_XSTR(__LINE__) ": " #dp "=%s\n", __FUNCTION__, VBoxDebugDevicePath2Str(dp)))
-#  define VBoxLogFlowFuncMarkHandleDP(dp)\
-    VBoxLog(("%a:" VBOX_XSTR(__LINE__) ": " #dp "=%s\n", __FUNCTION__, VBoxDebugHandleDevicePath2Str(dp)))
 #  define VBoxLog(a)                            VBoxLogWorker a
 # else  /* !EFI_LOG_ENABLED */
@@ -566,6 +558,4 @@
 #  define VBoxLogFlowFuncMarkVar(var, varfmt)   do {} while (0)
 #  define VBoxLogFlowFuncMarkRC(rc)             do {} while (0)
-#  define VBoxLogFlowFuncMarkDP(dp)             do {} while (0)
-#  define VBoxLogLogFlowFuncMarkHandleDP(dp)    do {} while (0)
 #  define VBoxLog(a)                            do {} while (0)
 # endif /* !EFI_LOG_ENABLED */
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/VBoxPkg/Library/VBoxDebugLib/VBoxDebugLib.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/VBoxPkg/Library/VBoxDebugLib/VBoxDebugLib.c	(revision 77671)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/VBoxPkg/Library/VBoxDebugLib/VBoxDebugLib.c	(revision 77672)
@@ -42,8 +42,4 @@
 #include "iprt/asm.h"
 
-#if 0
-static EFI_DEVICE_PATH_TO_TEXT_PROTOCOL *g_DevPath2Txt;
-#endif
-
 
 VOID EFIAPI
@@ -168,5 +164,5 @@
     VBoxPanicMsgString("\nLine:  ");
     VBoxPanicMsgDecimalU32((uint32_t)LineNumber);
-    VBoxPanicMsgString("\nEDescription: ");
+    VBoxPanicMsgString("\nDescription: ");
     VBoxPanicMsgString(Description ? Description : "<NULL>");
     ASMOutU8(EFI_PANIC_PORT, EFI_PANIC_CMD_END_MSG);
@@ -175,69 +171,4 @@
 }
 
-CHAR16 *VBoxDebugDevicePath2Str(IN EFI_DEVICE_PATH_PROTOCOL  *pDevicePath)
-{
-#if 0
-    EFI_STATUS rc;
-    if (!g_DevPath2Txt)
-    {
-        rc = gBS->LocateProtocol(&gEfiDevicePathToTextProtocolGuid, NULL, (VOID **)&g_DevPath2Txt);
-        if (EFI_ERROR(rc))
-        {
-            DEBUG((DEBUG_INFO, "gEfiDevicePathToTextProtocolGuid:%g isn't instantied\n", gEfiDevicePathToTextProtocolGuid));
-            return NULL;
-        }
-    }
-    return g_DevPath2Txt->ConvertDevicePathToText(pDevicePath, TRUE, FALSE);
-#else
-    return NULL;
-#endif
-}
-
-CHAR16 *VBoxDebugHandleDevicePath2Str(IN EFI_HANDLE hHandle)
-{
-#if 0
-    EFI_STATUS rc;
-    EFI_DEVICE_PATH_PROTOCOL *pDevicePath = NULL;
-    CHAR16 *psz16TxtDevicePath;
-    rc = gBS->OpenProtocol(hHandle,
-                           &gEfiDevicePathProtocolGuid,
-                           (VOID **)pDevicePath,
-                           NULL,
-                           hHandle,
-                           EFI_OPEN_PROTOCOL_BY_HANDLE_PROTOCOL);
-    if (EFI_ERROR(rc))
-    {
-        DEBUG((DEBUG_INFO, "%a:%d failed(%r) to open Device Path Protocol for Handle %p\n",
-                __FUNCTION__,
-                __LINE__,
-                rc,
-                hHandle));
-        return NULL;
-    }
-    psz16TxtDevicePath = VBoxDebugHandleDevicePath2Str(pDevicePath);
-    return psz16TxtDevicePath;
-#else
-    return NULL;
-#endif
-}
-CHAR16 *VBoxDebugPrintDevicePath(IN EFI_DEVICE_PATH_PROTOCOL  *pDevicePath)
-{
-#if 0
-    EFI_STATUS rc;
-    if (!g_DevPath2Txt)
-    {
-        rc = gBS->LocateProtocol(&gEfiDevicePathToTextProtocolGuid, NULL, (VOID **)&g_DevPath2Txt);
-        if (EFI_ERROR(rc))
-        {
-            DEBUG((DEBUG_INFO, "gEfiDevicePathToTextProtocolGuid:%g isn't instantied\n", gEfiDevicePathToTextProtocolGuid));
-            return NULL;
-        }
-    }
-    return g_DevPath2Txt->ConvertDevicePathToText(pDevicePath, TRUE, FALSE);
-#else
-    return NULL;
-#endif
-}
-
 
 VOID * EFIAPI
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/VBoxPkg/VBoxFsDxe/fsw_efi.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/VBoxPkg/VBoxFsDxe/fsw_efi.c	(revision 77671)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/VBoxPkg/VBoxFsDxe/fsw_efi.c	(revision 77672)
@@ -231,5 +231,4 @@
     // first, open DiskIO
     VBoxLogFlowFuncEnter();
-    VBoxLogFlowFuncMarkDP(RemainingDevicePath);
 
     Status = BS->OpenProtocol(ControllerHandle,