Index: trunk/src/VBox/Devices/Graphics/DevVGA_VBVA.cpp
===================================================================
--- trunk/src/VBox/Devices/Graphics/DevVGA_VBVA.cpp	(revision 77702)
+++ trunk/src/VBox/Devices/Graphics/DevVGA_VBVA.cpp	(revision 77703)
@@ -2216,8 +2216,8 @@
     RT_COPY_VOLATILE(screen, *pScreen);
     RT_UNTRUSTED_NONVOLATILE_COPY_FENCE();
-    LogRel(("VBVA: InfoScreen: [%d] @%d,%d %dx%d, line 0x%x, BPP %d, flags 0x%x\n",
-            screen.u32ViewIndex, screen.i32OriginX, screen.i32OriginY,
-            screen.u32Width, screen.u32Height,
-            screen.u32LineSize, screen.u16BitsPerPixel, screen.u16Flags));
+    LogRel2(("VBVA: InfoScreen: [%d] @%d,%d %dx%d, line 0x%x, BPP %d, flags 0x%x\n",
+             screen.u32ViewIndex, screen.i32OriginX, screen.i32OriginY,
+             screen.u32Width, screen.u32Height,
+             screen.u32LineSize, screen.u16BitsPerPixel, screen.u16Flags));
 
     /*
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIFrameBuffer.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIFrameBuffer.cpp	(revision 77702)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIFrameBuffer.cpp	(revision 77703)
@@ -766,8 +766,8 @@
     /* Widget resize is NOT thread-safe and *probably* never will be,
      * We have to notify machine-view with the async-signal to perform resize operation. */
-    LogRel(("GUI: UIFrameBufferPrivate::NotifyChange: Screen=%lu, Origin=%lux%lu, Size=%lux%lu, Sending to async-handler\n",
-            (unsigned long)uScreenId,
-            (unsigned long)uX, (unsigned long)uY,
-            (unsigned long)uWidth, (unsigned long)uHeight));
+    LogRel2(("GUI: UIFrameBufferPrivate::NotifyChange: Screen=%lu, Origin=%lux%lu, Size=%lux%lu, Sending to async-handler\n",
+             (unsigned long)uScreenId,
+             (unsigned long)uX, (unsigned long)uY,
+             (unsigned long)uWidth, (unsigned long)uHeight));
     emit sigNotifyChange(uWidth, uHeight);
 
@@ -1068,5 +1068,5 @@
 void UIFrameBufferPrivate::handleNotifyChange(int iWidth, int iHeight)
 {
-    LogRel(("GUI: UIFrameBufferPrivate::handleNotifyChange: Size=%dx%d\n", iWidth, iHeight));
+    LogRel2(("GUI: UIFrameBufferPrivate::handleNotifyChange: Size=%dx%d\n", iWidth, iHeight));
 
     /* Make sure machine-view is assigned: */
@@ -1180,6 +1180,6 @@
     if (m_sourceBitmap.isNull())
     {
-        LogRel(("GUI: UIFrameBufferPrivate::performResize: Size=%dx%d, "
-                "Using fallback buffer since no source bitmap is provided\n", iWidth, iHeight));
+        LogRel(("GUI: UIFrameBufferPrivate::performResize: Size=%dx%d, Using fallback buffer since no source bitmap is provided\n",
+                iWidth, iHeight));
 
         /* Remember new size came from hint: */
@@ -1194,6 +1194,6 @@
     else
     {
-        LogRel(("GUI: UIFrameBufferPrivate::performResize: Size=%dx%d, "
-                "Directly using source bitmap content\n", iWidth, iHeight));
+        LogRel2(("GUI: UIFrameBufferPrivate::performResize: Size=%dx%d, Directly using source bitmap content\n",
+                 iWidth, iHeight));
 
         /* Acquire source-bitmap attributes: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 77702)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 77703)
@@ -338,6 +338,6 @@
 void UIMachineView::sltHandleNotifyChange(int iWidth, int iHeight)
 {
-    LogRel(("GUI: UIMachineView::sltHandleNotifyChange: Screen=%d, Size=%dx%d\n",
-            (unsigned long)m_uScreenId, iWidth, iHeight));
+    LogRel2(("GUI: UIMachineView::sltHandleNotifyChange: Screen=%d, Size=%dx%d\n",
+             (unsigned long)m_uScreenId, iWidth, iHeight));
 
     /* Some situations require frame-buffer resize-events to be ignored at all,
@@ -1035,7 +1035,6 @@
 {
     /* Save guest-screen size-hint: */
-    LogRel(("GUI: UIMachineView::storeGuestSizeHint: "
-            "Storing guest-screen size-hint for screen %d as %dx%d\n",
-            (int)screenId(), sizeHint.width(), sizeHint.height()));
+    LogRel2(("GUI: UIMachineView::storeGuestSizeHint: Storing guest-screen size-hint for screen %d as %dx%d\n",
+             (int)screenId(), sizeHint.width(), sizeHint.height()));
     gEDataManager->setLastGuestScreenSizeHint(m_uScreenId, sizeHint, vboxGlobal().managedVMUuid());
 }
Index: trunk/src/VBox/Main/src-client/DisplayImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/DisplayImpl.cpp	(revision 77702)
+++ trunk/src/VBox/Main/src-client/DisplayImpl.cpp	(revision 77703)
@@ -919,6 +919,6 @@
                                    int32_t xOrigin, int32_t yOrigin, bool fVGAResize)
 {
-    LogRel(("Display::handleDisplayResize: uScreenId=%d pvVRAM=%p w=%d h=%d bpp=%d cbLine=0x%X flags=0x%X\n", uScreenId,
-            pvVRAM, w, h, bpp, cbLine, flags));
+    LogRel2(("Display::i_handleDisplayResize: uScreenId=%d pvVRAM=%p w=%d h=%d bpp=%d cbLine=0x%X flags=0x%X\n", uScreenId,
+             pvVRAM, w, h, bpp, cbLine, flags));
 
     /* Caller must not hold the object lock. */
@@ -957,5 +957,9 @@
 
     if (uScreenId >= mcMonitors)
+    {
+        LogRel(("Display::i_handleDisplayResize: mcMonitors=%u < uScreenId=%u (pvVRAM=%p w=%u h=%u bpp=%d cbLine=0x%X flags=0x%X)\n",
+                mcMonitors, uScreenId, pvVRAM, w, h, bpp, cbLine, flags));
         return VINF_SUCCESS;
+    }
 
     DISPLAYFBINFO *pFBInfo = &maFramebuffers[uScreenId];
@@ -993,4 +997,16 @@
         h = pFBInfo->h;
     }
+
+    /* Log changes. */
+    if (   pFBInfo->w != w
+        || pFBInfo->h != h
+        || pFBInfo->u32LineSize != cbLine
+        /*|| pFBInfo->pu8FramebufferVRAM != (uint8_t *)pvVRAM - too noisy */
+        || (   !fVGAResize
+            && (   pFBInfo->xOrigin != xOrigin
+                || pFBInfo->yOrigin != yOrigin
+                || pFBInfo->flags != flags)))
+        LogRel(("Display::i_handleDisplayResize: uScreenId=%d pvVRAM=%p w=%d h=%d bpp=%d cbLine=0x%X flags=0x%X origin=%d,%d\n",
+                uScreenId, pvVRAM, w, h, bpp, cbLine, flags, xOrigin, yOrigin));
 
     /* Update the video mode information. */