Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 77844)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 77845)
@@ -3059,5 +3059,5 @@
 }
 
-bool UIExtraDataManager::showMachineInSelectorChooser(const QUuid &uID)
+bool UIExtraDataManager::showMachineInVirtualBoxManagerChooser(const QUuid &uID)
 {
     /* 'True' unless 'restriction' feature allowed: */
@@ -3065,5 +3065,5 @@
 }
 
-bool UIExtraDataManager::showMachineInSelectorDetails(const QUuid &uID)
+bool UIExtraDataManager::showMachineInVirtualBoxManagerDetails(const QUuid &uID)
 {
     /* 'True' unless 'restriction' feature allowed: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 77844)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 77845)
@@ -412,8 +412,8 @@
     /** @name Virtual Machine
       * @{ */
-        /** Returns whether machine should be shown in selector-window chooser-pane. */
-        bool showMachineInSelectorChooser(const QUuid &uID);
-        /** Returns whether machine should be shown in selector-window details-pane. */
-        bool showMachineInSelectorDetails(const QUuid &uID);
+        /** Returns whether machine should be shown in VirtualBox Manager Chooser-pane. */
+        bool showMachineInVirtualBoxManagerChooser(const QUuid &uID);
+        /** Returns whether machine should be shown in VirtualBox Manager Details-pane. */
+        bool showMachineInVirtualBoxManagerDetails(const QUuid &uID);
 
         /** Returns whether machine reconfiguration enabled. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItem.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItem.cpp	(revision 77844)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItem.cpp	(revision 77845)
@@ -156,5 +156,5 @@
 
         /* Should we show details for this item? */
-        m_fHasDetails = gEDataManager->showMachineInSelectorDetails(m_uId);
+        m_fHasDetails = gEDataManager->showMachineInVirtualBoxManagerDetails(m_uId);
     }
     else
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 77844)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 77845)
@@ -741,5 +741,5 @@
         /* Show machine if we should: */
         CMachine comMachine = vboxGlobal().virtualBox().FindMachine(uId.toString());
-        if (gEDataManager->showMachineInSelectorChooser(uId))
+        if (gEDataManager->showMachineInVirtualBoxManagerChooser(uId))
         {
             /* Add new machine-item: */
@@ -1041,5 +1041,5 @@
     /* Show machine if we should: */
     CMachine comMachine = vboxGlobal().virtualBox().FindMachine(uId.toString());
-    if (gEDataManager->showMachineInSelectorChooser(uId))
+    if (gEDataManager->showMachineInVirtualBoxManagerChooser(uId))
     {
         /* Add new machine-item: */
@@ -1690,6 +1690,5 @@
         {
             const QUuid uMachineID = comMachine.GetId();
-            /// @todo rename showMachineInSelectorChooser to showMachineInVirtualBoxManager
-            if (!uMachineID.isNull() && gEDataManager->showMachineInSelectorChooser(uMachineID))
+            if (!uMachineID.isNull() && gEDataManager->showMachineInVirtualBoxManagerChooser(uMachineID))
                 addMachineIntoTheTree(comMachine);
         }
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMedium.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMedium.cpp	(revision 77844)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMedium.cpp	(revision 77845)
@@ -340,5 +340,5 @@
 
                 /* Finally we can precisely check if current machine is 'hidden': */
-                if (gEDataManager->showMachineInSelectorChooser(uMachineID))
+                if (gEDataManager->showMachineInVirtualBoxManagerChooser(uMachineID))
                     m_fUsedByHiddenMachinesOnly = false;
 